#version 130
#ifdef VERTEX_SHADER_SOURCE

uniform mat4 mvMat;
uniform mat4 projMat;

in vec2 inVertex;
in vec2 inTexCoord;
in vec4 inColor;
out vec4 color;
out vec2 texCoord;

void main(void)
{
	mat4 finalMatrix = projMat * mvMat;
	gl_Position = finalMatrix * vec4(inVertex, 0.0, 1.0);
	color = inColor;
	texCoord = inTexCoord;
}
#endif

#ifdef FRAGMENT_SHADER_SOURCE
uniform sampler2D texture0;

in vec4 color;
in  vec2 texCoord;
out vec4 outColor;

void main(void)
{
	outColor = color*texture(texture0, texCoord.st);
	//if(outColor.a < 0.3)
	//	discard;
}
#endif
