#version 130
#ifdef VERTEX_SHADER_SOURCE

uniform mat4 mvMat;
uniform mat4 projMat;

in vec2 inVertex;
in vec2 inTexCoord;
in vec4 inColor;
out vec4 color;
out vec2 texCoord;

void main(void)
{
	mat4 finalMatrix = projMat * mvMat;
	gl_Position = finalMatrix * vec4(inVertex, 0.0, 1.0);
	color = inColor;
	texCoord = inTexCoord;
}
#endif

#ifdef FRAGMENT_SHADER_SOURCE
uniform sampler2D texture0;
uniform sampler2D texture1;//normal world
uniform sampler2D texture2;//other world

in vec4 color;
in  vec2 texCoord;
out vec4 outColor;

void main(void)
{
	float ratio = texture(texture0, texCoord.st).r;
	if(ratio == 1.0)
		outColor = texture(texture1, texCoord.st);
	else if(ratio == 0.0)
		outColor = texture(texture2, texCoord.st);
	else
	{
		vec4 color1 = texture(texture1, texCoord.st);
		vec4 color2 = texture(texture2, texCoord.st);
		outColor = mix(color1, color2, 1-ratio);
	}
}
#endif
