#version 130
#ifdef VERTEX_SHADER_SOURCE

uniform mat4 mvMat;
uniform mat4 projMat;

uniform mat4 joints[8];

in vec3 inVertex;
in vec2 inTexCoord;
in vec3 inColor;
in vec3 inNormal;
in ivec4 inJoints;
in vec4 inWeights;
in int inMeshIndex;
out vec4 color;
out vec2 texCoord;
out vec4 normal;

void main(void)
{
	mat4 finalMatrix = projMat * mvMat;

	mat4 boneTransform = (joints[inJoints.x] * inWeights.x)
		+ (joints[inJoints.y] * inWeights.y)
		+ (joints[inJoints.z] * inWeights.z)
		+ (joints[inJoints.w] * inWeights.w);

	vec4 skinnedPosition = boneTransform * vec4(inVertex, 1.0);
	gl_Position = finalMatrix * skinnedPosition;
	color = vec4(inColor, 1.0);
	texCoord = inTexCoord;
	normal = vec4(inNormal, 1.0);
}

#endif

#ifdef FRAGMENT_SHADER_SOURCE

uniform sampler2D texture0;

in vec4 color;
in  vec2 texCoord;
out vec4 outColor;

void main(void)
{
	outColor = color*texture(texture0, texCoord.st);
	if(outColor.a < 0.2)
		discard;
}
#endif
