#version 130
#ifdef VERTEX_SHADER_SOURCE

uniform vec3 pos;
uniform vec3 scale;

in vec2 inVertex;
in vec2 inTexCoord;
in vec4 inColor;
out vec4 color;
out vec2 texCoord;

void main(void) 
{
	gl_Position = (vec4(scale, 1.0) * vec4(inVertex, 0.0, 1.0)) + vec4(pos, 0.0);
	texCoord = inTexCoord;
	color = inColor;
}
#endif

#ifdef FRAGMENT_SHADER_SOURCE
uniform sampler2D texture0;

in vec4 color;
in  vec2 texCoord;
out vec4 outColor;

void main(void)
{
	float alpha = texture(texture0, texCoord.st).r;
	outColor = vec4(color.rgb, alpha * color.a);
}
#endif