
struct PSInput
{
	float4 position : SV_POSITION;
	float2 uv : TEXCOORD;
	float4 vertexColor : COLOR;
};

cbuffer ConstantBuffer : register(b0)
{
	float3 pos;
	float3 scale;
};

Texture2D texture0 : register(t0);
SamplerState g_sampler : register(s0);

PSInput VSMain(float2 inVertex : POSITION, float2 inTexCoord : TEXCOORD, float4 color : COLOR)
{
	PSInput result;

	result.position = (float4(scale, 1.0) * float4(inVertex, 0.0, 1.0)) + float4(pos, 0.0);
	result.uv = inTexCoord;
	result.vertexColor = color;

	return result;
}

float4 PSMain(PSInput input) : SV_TARGET
{
	float alpha = texture0.Sample(g_sampler, input.uv).r;
	float4 outColor = float4(input.vertexColor.rgb, alpha * input.vertexColor.a);
	return outColor;
}
