#version 130
#ifdef VERTEX_SHADER_SOURCE

uniform mat4 modelMat;
uniform mat4 mvMat;
uniform mat4 projMat;
uniform vec3 sphereCenters[8];
uniform float sphereRadii[8];

in vec3 inVertex;
in vec2 inTexCoord;
in vec3 inColor;
in vec3 inNormal;
out vec4 worldPosition;

void main(void)
{
	mat4 finalMatrix = projMat * mvMat;
	gl_Position = finalMatrix * vec4(inVertex, 1.0);
	worldPosition = modelMat * vec4(inVertex, 1.0);
}
#endif

#ifdef FRAGMENT_SHADER_SOURCE
uniform sampler2D texture0;
uniform vec3 sphereCenters[8];
uniform float sphereRadii[8];

in vec4 color;
in vec4 worldPosition;
in  vec2 texCoord;
out vec4 outColor;

void main(void) {
	outColor = vec4(1.0, 0.0, 0.0, 1.0);
	float distance = length(worldPosition.xyz - sphereCenters[0]);
	if(distance < sphereRadii[0] + 0.1f * sphereRadii[0])
	{
		float ratio = clamp(((distance - sphereRadii[0]) / (0.1 * sphereRadii[0])), 0.0f, 1.0f);
		outColor = mix(vec4(0.0f, 0.0f, 0.0f, 1.0f), vec4(1.0f, 0.0f, 0.0f, 1.0f), ratio);
	}
	else
		discard;
	//if(outColor.a < 0.3)
	//	discard;
}
#endif
